function [i, j, k, value] = binary_search(lower, upper,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car)        
% performs a binary search to find the smallest acceleration value
% takes inputs of lower and upper constraint aswell as states and constants
% needed for acceleration calculation

% finds the middle value
mid = floor((upper + lower)/2);

% performs binary search
if lower < mid-1 && upper > mid+1
    [im, jm, km, valuem] = calc_acc(mid-1,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car);
    [ip, jp, kp, valuep] = calc_acc(mid+1,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car);
    [imid, jmid, kmid, valuemid] = calc_acc(mid,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car);
    if  valuem > valuemid && valuemid < valuep
        i = imid;
        j = jmid;
        k = kmid;
        value = valuemid;
    elseif valuem < valuep
        [i, j, k, value] = binary_search(lower,mid-1,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car);  
    else
        [i, j, k, value] = binary_search(mid+1,upper,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car);
    end
elseif (mid-1 < mid && mid < mid+1) || (mid-1 > mid && mid > mid+1)
    [i, j, k, value] = calc_acc(mid,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car);
elseif lower == mid-1
    [i, j, k, value] = calc_acc(mid-1,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car);
elseif upper == mid+1
    [i, j, k, value] = calc_acc(mid+1,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car);
else
    [i, j, k, value] = calc_acc(mid,delta0,omega_m0,V0,beta0,gain,l_front,l_rear,l_tread,m_car,r_wheel,road_condition,C_rolling,C_air,rho_air,A_front,A_side,...
        h_cg,I_car,r_fl,r_fr,theta_fl,theta_fr,l_car);
end