function [dmylong_du_fl,dmylong_du_fr,dmylong_du_rl,dmylong_du_rr, dmylong_dv_fl,dmylong_dv_fr,dmylong_dv_rl,dmylong_dv_rr,...
    dmylong_dpsidot_fl,dmylong_dpsidot_fr,dmylong_dpsidot_rl,dmylong_dpsidot_rr,dmylong_ddelta_fl,dmylong_ddelta_fr,dmylong_ddelta_rl,dmylong_ddelta_rr,...
    dmylong_dXR_fl,dmylong_dXR_fr,dmylong_dXR_rl,dmylong_dXR_rr,dmylat_du_fl,dmylat_du_fr,dmylat_du_rl,dmylat_du_rr,...
    dmylat_dv_fl,dmylat_dv_fr,dmylat_dv_rl,dmylat_dv_rr, dmylat_dpsidot_fl,dmylat_dpsidot_fr,dmylat_dpsidot_rl,dmylat_dpsidot_rr,...
    dmylat_ddelta_fl,dmylat_ddelta_fr,dmylat_ddelta_rl,dmylat_ddelta_rr,dmylat_dXR_fl,dmylat_dXR_fr,dmylat_dXR_rl,dmylat_dXR_rr,my_long0,my_lat0] = find_mu(road_condition,...
    deltass, omega_mss,omega_flss, step, V0values, beta0values,l_front,l_rear,l_tread,r_wheel,r_fl,r_fr,theta_fl,theta_fr)

% initiates all the variables needed in calculation
    [n,m] = size(deltass);
    dmylong_du_fl = zeros(n,m);
    dmylong_du_fr = zeros(n,m);
    dmylong_du_rl = zeros(n,m);
    dmylong_du_rr = zeros(n,m);
    
    dmylong_dv_fl = zeros(n,m);
    dmylong_dv_fr = zeros(n,m);
    dmylong_dv_rl = zeros(n,m);
    dmylong_dv_rr = zeros(n,m);
    
    dmylong_dpsidot_fl = zeros(n,m);
    dmylong_dpsidot_fr = zeros(n,m);
    dmylong_dpsidot_rl = zeros(n,m);
    dmylong_dpsidot_rr = zeros(n,m);
    
    dmylong_ddelta_fl = zeros(n,m);
    dmylong_ddelta_fr = zeros(n,m);
    dmylong_ddelta_rl = zeros(n,m);
    dmylong_ddelta_rr = zeros(n,m);
    
    dmylong_dXR_fl = zeros(n,m);
    dmylong_dXR_fr = zeros(n,m);
    dmylong_dXR_rl = zeros(n,m);
    dmylong_dXR_rr = zeros(n,m);
    
    dmylat_du_fl = zeros(n,m);
    dmylat_du_fr = zeros(n,m);
    dmylat_du_rl = zeros(n,m);
    dmylat_du_rr = zeros(n,m);
    
    dmylat_dv_fl = zeros(n,m);
    dmylat_dv_fr = zeros(n,m);
    dmylat_dv_rl = zeros(n,m);
    dmylat_dv_rr = zeros(n,m);
    
    dmylat_dpsidot_fl = zeros(n,m);
    dmylat_dpsidot_fr = zeros(n,m);
    dmylat_dpsidot_rl = zeros(n,m);
    dmylat_dpsidot_rr = zeros(n,m);
    
    dmylat_ddelta_fl = zeros(n,m);
    dmylat_ddelta_fr = zeros(n,m);
    dmylat_ddelta_rl = zeros(n,m);
    dmylat_ddelta_rr = zeros(n,m);
    
    dmylat_dXR_fl = zeros(n,m);
    dmylat_dXR_fr = zeros(n,m);
    dmylat_dXR_rl = zeros(n,m);
    dmylat_dXR_rr = zeros(n,m);
    
% finds the friction coefficient derivatives
    for i = 1:n
        for j = 1:m
        beta0 = beta0values(i);
        V0 = V0values(j);
        u0 = V0*cos(beta0);
        v0 = V0*sin(beta0);
        w0 = 0; 

        delta0 = deltass(i,j);
        omega_m0 = omega_mss(i,j);
        omega_fl0 = omega_flss(i,j);

        Vrot_fl = omega_fl0*r_wheel;
        r0 = ((V0*(cos(beta0)*cos(delta0) + sin(beta0)*sin(delta0)) - Vrot_fl)/(r_fl*(sin(theta_fl)*cos(delta0) - cos(theta_fl)*sin(delta0))));
        v_wheel_fr0 = [V0*cos(beta0) + r0*r_fr*cos(theta_fr); V0*sin(beta0) + r0*r_fr*sin(theta_fr)];
        Vw_fr0 = norm(v_wheel_fr0);
        omega_fr0 = (1/r_wheel)*(cos(delta0 - atan2(v_wheel_fr0(2),v_wheel_fr0(1)))*Vw_fr0);
        omega_wheel = [omega_fl0;omega_fr0;omega_m0;omega_m0];

        linvel0 = [u0;v0;w0];
        [v_rotation0, v_wheel0, sigma_long0, sigma_lat0, sigma_res0, alpha0, beta] = wheel_slip(delta0, linvel0, r0, omega_wheel, l_front, l_rear, l_tread, r_wheel);
        [my_long0, my_lat0] = friction_coefficient(linvel0, sigma_long0, sigma_lat0, sigma_res0, road_condition);
        
        linvelu_eps = [u0+step;v0;w0];
        [v_rotation0, v_wheel0, sigma_long0, sigma_lat0, sigma_res0, alpha0, beta] = wheel_slip(delta0, linvelu_eps, r0, omega_wheel, l_front, l_rear, l_tread, r_wheel);
        [my_long0u, my_lat0u] = friction_coefficient(linvelu_eps, sigma_long0, sigma_lat0, sigma_res0, road_condition);

        % derivatives with respect to the axial speed
        dmylong_du_fl(i,j) = (my_long0u(1) - my_long0(1))/step;
        dmylong_du_fr(i,j) = (my_long0u(2) - my_long0(2))/step;
        dmylong_du_rl(i,j) = (my_long0u(3) - my_long0(3))/step;
        dmylong_du_rr(i,j) = (my_long0u(4) - my_long0(4))/step;
        
        dmylat_du_fl(i,j) = (my_lat0u(1) - my_lat0(1))/step;
        dmylat_du_fr(i,j) = (my_lat0u(2) - my_lat0(2))/step;
        dmylat_du_rl(i,j) = (my_lat0u(3) - my_lat0(3))/step;
        dmylat_du_rr(i,j) = (my_lat0u(4) - my_lat0(4))/step;
        
        linvelv_eps = [u0;v0+step;w0];
        [v_rotation0, v_wheel0, sigma_long0, sigma_lat0, sigma_res0, alpha0, beta] = wheel_slip(delta0, linvelv_eps, r0, omega_wheel, l_front, l_rear, l_tread, r_wheel);
        [my_long0v, my_lat0v] = friction_coefficient(linvelv_eps, sigma_long0, sigma_lat0, sigma_res0, road_condition);
        
        % derivatives with respect to the lateral speed
        dmylong_dv_fl(i,j) = (my_long0v(1) - my_long0(1))/step;
        dmylong_dv_fr(i,j) = (my_long0v(2) - my_long0(2))/step;
        dmylong_dv_rl(i,j) = (my_long0v(3) - my_long0(3))/step;
        dmylong_dv_rr(i,j) = (my_long0v(4) - my_long0(4))/step;
        
        dmylat_dv_fl(i,j) = (my_lat0v(1) - my_lat0(1))/step;
        dmylat_dv_fr(i,j) = (my_lat0v(2) - my_lat0(2))/step;
        dmylat_dv_rl(i,j) = (my_lat0v(3) - my_lat0(3))/step;
        dmylat_dv_rr(i,j) = (my_lat0v(4) - my_lat0(4))/step;

        r_eps = r0+step;
        [v_rotation0, v_wheel0, sigma_long0, sigma_lat0, sigma_res0, alpha0, beta] = wheel_slip(delta0, linvel0, r_eps, omega_wheel, l_front, l_rear, l_tread, r_wheel);
        [my_long0r, my_lat0r] = friction_coefficient(linvel0, sigma_long0, sigma_lat0, sigma_res0, road_condition);
        
        % derivatives with respect to the yaw rate
        dmylong_dpsidot_fl(i,j) = (my_long0r(1) - my_long0(1))/step;
        dmylong_dpsidot_fr(i,j) = (my_long0r(2) - my_long0(2))/step;
        dmylong_dpsidot_rl(i,j) = (my_long0r(3) - my_long0(3))/step;
        dmylong_dpsidot_rr(i,j) = (my_long0r(4) - my_long0(4))/step;
        
        dmylat_dpsidot_fl(i,j) = (my_lat0r(1) - my_lat0(1))/step;
        dmylat_dpsidot_fr(i,j) = (my_lat0r(2) - my_lat0(2))/step;
        dmylat_dpsidot_rl(i,j) = (my_lat0r(3) - my_lat0(3))/step;
        dmylat_dpsidot_rr(i,j) = (my_lat0r(4) - my_lat0(4))/step;
        
        linvel0 = [u0;v0;w0];
        delta_eps = delta0 + step;
        [v_rotation0, v_wheel0, sigma_long0, sigma_lat0, sigma_res0, alpha0, beta] = wheel_slip(delta_eps, linvel0, r0, omega_wheel, l_front, l_rear, l_tread, r_wheel);
        [my_long0r, my_lat0r] = friction_coefficient(linvel0, sigma_long0, sigma_lat0, sigma_res0, road_condition);
        
        % derivatives with respect to the steering angle
        dmylong_ddelta_fl(i,j) = (my_long0r(1) - my_long0(1))/step;
        dmylong_ddelta_fr(i,j) = (my_long0r(2) - my_long0(2))/step;
        dmylong_ddelta_rl(i,j) = (my_long0r(3) - my_long0(3))/step;
        dmylong_ddelta_rr(i,j) = (my_long0r(4) - my_long0(4))/step;
        
        dmylat_ddelta_fl(i,j) = (my_lat0r(1) - my_lat0(1))/step;
        dmylat_ddelta_fr(i,j) = (my_lat0r(2) - my_lat0(2))/step;
        dmylat_ddelta_rl(i,j) = (my_lat0r(3) - my_lat0(3))/step;
        dmylat_ddelta_rr(i,j) = (my_lat0r(4) - my_lat0(4))/step;
        

        omega_eps = [omega_fl0;omega_fr0;omega_m0+step;omega_m0+step];
        [v_rotation0, v_wheel0, sigma_long0, sigma_lat0, sigma_res0, alpha0, beta] = wheel_slip(delta0, linvel0, r0, omega_eps, l_front, l_rear, l_tread, r_wheel);
        [my_long0r, my_lat0r] = friction_coefficient(linvel0, sigma_long0, sigma_lat0, sigma_res0, road_condition);
        
        % derivatives with respect to the throttle
        dmylong_dXR_fl(i,j) = (my_long0r(1) - my_long0(1))/step;
        dmylong_dXR_fr(i,j) = (my_long0r(2) - my_long0(2))/step;
        dmylong_dXR_rl(i,j) = (my_long0r(3) - my_long0(3))/step;
        dmylong_dXR_rr(i,j) = (my_long0r(4) - my_long0(4))/step;
        
        dmylat_dXR_fl(i,j) = (my_lat0r(1) - my_lat0(1))/step;
        dmylat_dXR_fr(i,j) = (my_lat0r(2) - my_lat0(2))/step;
        dmylat_dXR_rl(i,j) = (my_lat0r(3) - my_lat0(3))/step;
        dmylat_dXR_rr(i,j) = (my_lat0r(4) - my_lat0(4))/step;
        
        end
    end

