function [Fx_wheel, Fy_wheel, X_R]= horizontal_wheel_forces(Fz_wheel, my_long, my_lat, alpha)

% vertical forces
Fz_fl = Fz_wheel(1);
Fz_fr = Fz_wheel(2);
Fz_rl = Fz_wheel(3);
Fz_rr = Fz_wheel(4);

% longitudinal friction
my_long_fl = my_long(1);
my_long_fr = my_long(2);
my_long_rl = my_long(3);
my_long_rr = my_long(4);

% lateral friction
my_lat_fl = my_lat(1);
my_lat_fr = my_lat(2);
my_lat_rl = my_lat(3);
my_lat_rr = my_lat(4);

% slip angle
alpha_fl = alpha(1);
alpha_fr = alpha(2);
alpha_rl = alpha(3);
alpha_rr = alpha(4);

% rotation matrix from wheel velocity to wheel frame 
R_fl = [ cos(alpha_fl) sin(alpha_fl);
        -sin(alpha_fl) cos(alpha_fl)];
R_fr = [ cos(alpha_fr) sin(alpha_fr);
        -sin(alpha_fr) cos(alpha_fr)];
R_rl = [ cos(alpha_rl) sin(alpha_rl);
        -sin(alpha_rl) cos(alpha_rl)];
R_rr = [ cos(alpha_rr) sin(alpha_rr);
        -sin(alpha_rr) cos(alpha_rr)];    

% friction force
F_friction_fl = R_fl*[my_long_fl*Fz_fl my_lat_fl*Fz_fl]';
F_friction_fr = R_fr*[my_long_fr*Fz_fr my_lat_fr*Fz_fr]';
F_friction_rl = R_rl*[my_long_rl*Fz_rl my_lat_rl*Fz_rl]';
F_friction_rr = R_rr*[my_long_rr*Fz_rr my_lat_rr*Fz_rr]';

% output
Fx_wheel = [F_friction_fl(1) F_friction_fr(1) F_friction_rl(1) F_friction_rr(1)]';
Fy_wheel = [F_friction_fl(2) F_friction_fr(2) F_friction_rl(2) F_friction_rr(2)]';

X_R = Fx_wheel(3) + Fx_wheel(4);


