/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c19_carsim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c19_debug_family_names[16] = { "K", "T", "u", "alpha",
  "nargin", "nargout", "v", "beta", "psi_dot", "l_front", "tau", "delta",
  "m_car", "mu", "th", "st" };

/* Function Declarations */
static void initialize_c19_carsim(SFc19_carsimInstanceStruct *chartInstance);
static void initialize_params_c19_carsim(SFc19_carsimInstanceStruct
  *chartInstance);
static void enable_c19_carsim(SFc19_carsimInstanceStruct *chartInstance);
static void disable_c19_carsim(SFc19_carsimInstanceStruct *chartInstance);
static void c19_update_debugger_state_c19_carsim(SFc19_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c19_carsim(SFc19_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c19_carsim(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_st);
static void finalize_c19_carsim(SFc19_carsimInstanceStruct *chartInstance);
static void sf_c19_carsim(SFc19_carsimInstanceStruct *chartInstance);
static void c19_chartstep_c19_carsim(SFc19_carsimInstanceStruct *chartInstance);
static void initSimStructsc19_carsim(SFc19_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c19_machineNumber, uint32_T
  c19_chartNumber);
static const mxArray *c19_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData);
static real_T c19_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_st, const char_T *c19_identifier);
static real_T c19_b_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId);
static void c19_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData);
static const mxArray *c19_b_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData);
static const mxArray *c19_c_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData);
static void c19_c_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId, real_T c19_y[2]);
static void c19_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData);
static const mxArray *c19_d_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData);
static void c19_d_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId, real_T c19_y[6]);
static void c19_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData);
static const mxArray *c19_e_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData);
static void c19_e_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId, real_T c19_y[4]);
static void c19_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData);
static void c19_info_helper(c19_ResolvedFunctionInfo c19_info[19]);
static real_T c19_mrdivide(SFc19_carsimInstanceStruct *chartInstance, real_T
  c19_A, real_T c19_B);
static void c19_eml_scalar_eg(SFc19_carsimInstanceStruct *chartInstance);
static void c19_mldivide(SFc19_carsimInstanceStruct *chartInstance, real_T
  c19_A[4], real_T c19_B[6], real_T c19_Y[6]);
static void c19_eml_warning(SFc19_carsimInstanceStruct *chartInstance);
static void c19_b_eml_scalar_eg(SFc19_carsimInstanceStruct *chartInstance);
static const mxArray *c19_f_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData);
static int32_T c19_f_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId);
static void c19_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData);
static uint8_T c19_g_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_b_is_active_c19_carsim, const char_T *c19_identifier);
static uint8_T c19_h_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId);
static void init_dsm_address_info(SFc19_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c19_carsim(SFc19_carsimInstanceStruct *chartInstance)
{
  chartInstance->c19_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c19_is_active_c19_carsim = 0U;
}

static void initialize_params_c19_carsim(SFc19_carsimInstanceStruct
  *chartInstance)
{
  real_T c19_d0;
  real_T c19_d1;
  real_T c19_d2;
  sf_set_error_prefix_string(
    "Error evaluating data 'l_front' in the parent workspace.\n");
  sf_mex_import_named("l_front", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c19_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c19_l_front = c19_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'm_car' in the parent workspace.\n");
  sf_mex_import_named("m_car", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c19_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c19_m_car = c19_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'mu' in the parent workspace.\n");
  sf_mex_import_named("mu", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      &c19_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c19_mu = c19_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c19_carsim(SFc19_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c19_carsim(SFc19_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c19_update_debugger_state_c19_carsim(SFc19_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c19_carsim(SFc19_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c19_st;
  const mxArray *c19_y = NULL;
  real_T c19_hoistedGlobal;
  real_T c19_u;
  const mxArray *c19_b_y = NULL;
  real_T c19_b_hoistedGlobal;
  real_T c19_b_u;
  const mxArray *c19_c_y = NULL;
  uint8_T c19_c_hoistedGlobal;
  uint8_T c19_c_u;
  const mxArray *c19_d_y = NULL;
  real_T *c19_b_st;
  real_T *c19_th;
  c19_b_st = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c19_th = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c19_st = NULL;
  c19_st = NULL;
  c19_y = NULL;
  sf_mex_assign(&c19_y, sf_mex_createcellarray(3), FALSE);
  c19_hoistedGlobal = *c19_b_st;
  c19_u = c19_hoistedGlobal;
  c19_b_y = NULL;
  sf_mex_assign(&c19_b_y, sf_mex_create("y", &c19_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c19_y, 0, c19_b_y);
  c19_b_hoistedGlobal = *c19_th;
  c19_b_u = c19_b_hoistedGlobal;
  c19_c_y = NULL;
  sf_mex_assign(&c19_c_y, sf_mex_create("y", &c19_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c19_y, 1, c19_c_y);
  c19_c_hoistedGlobal = chartInstance->c19_is_active_c19_carsim;
  c19_c_u = c19_c_hoistedGlobal;
  c19_d_y = NULL;
  sf_mex_assign(&c19_d_y, sf_mex_create("y", &c19_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c19_y, 2, c19_d_y);
  sf_mex_assign(&c19_st, c19_y, FALSE);
  return c19_st;
}

static void set_sim_state_c19_carsim(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_st)
{
  const mxArray *c19_u;
  real_T *c19_b_st;
  real_T *c19_th;
  c19_b_st = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c19_th = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c19_doneDoubleBufferReInit = TRUE;
  c19_u = sf_mex_dup(c19_st);
  *c19_b_st = c19_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c19_u, 0)), "st");
  *c19_th = c19_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c19_u,
    1)), "th");
  chartInstance->c19_is_active_c19_carsim = c19_g_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c19_u, 2)), "is_active_c19_carsim");
  sf_mex_destroy(&c19_u);
  c19_update_debugger_state_c19_carsim(chartInstance);
  sf_mex_destroy(&c19_st);
}

static void finalize_c19_carsim(SFc19_carsimInstanceStruct *chartInstance)
{
}

static void sf_c19_carsim(SFc19_carsimInstanceStruct *chartInstance)
{
  int32_T c19_i0;
  real_T *c19_v;
  real_T *c19_beta;
  real_T *c19_psi_dot;
  real_T *c19_delta;
  real_T *c19_th;
  real_T *c19_st;
  real_T (*c19_tau)[3];
  c19_st = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c19_th = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c19_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c19_tau = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c19_psi_dot = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c19_beta = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c19_v = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 8U, chartInstance->c19_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c19_v, 0U);
  _SFD_DATA_RANGE_CHECK(*c19_beta, 1U);
  _SFD_DATA_RANGE_CHECK(*c19_psi_dot, 2U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c19_l_front, 3U);
  for (c19_i0 = 0; c19_i0 < 3; c19_i0++) {
    _SFD_DATA_RANGE_CHECK((*c19_tau)[c19_i0], 4U);
  }

  _SFD_DATA_RANGE_CHECK(*c19_delta, 5U);
  _SFD_DATA_RANGE_CHECK(*c19_th, 6U);
  _SFD_DATA_RANGE_CHECK(*c19_st, 7U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c19_m_car, 8U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c19_mu, 9U);
  chartInstance->c19_sfEvent = CALL_EVENT;
  c19_chartstep_c19_carsim(chartInstance);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c19_chartstep_c19_carsim(SFc19_carsimInstanceStruct *chartInstance)
{
  real_T c19_hoistedGlobal;
  real_T c19_b_hoistedGlobal;
  real_T c19_c_hoistedGlobal;
  real_T c19_d_hoistedGlobal;
  real_T c19_e_hoistedGlobal;
  real_T c19_f_hoistedGlobal;
  real_T c19_g_hoistedGlobal;
  real_T c19_v;
  real_T c19_beta;
  real_T c19_psi_dot;
  real_T c19_b_l_front;
  int32_T c19_i1;
  real_T c19_tau[3];
  real_T c19_delta;
  real_T c19_b_m_car;
  real_T c19_b_mu;
  uint32_T c19_debug_family_var_map[16];
  real_T c19_K[4];
  real_T c19_T[6];
  real_T c19_u[2];
  real_T c19_alpha;
  real_T c19_nargin = 8.0;
  real_T c19_nargout = 2.0;
  real_T c19_th;
  real_T c19_st;
  real_T c19_a;
  real_T c19_b;
  real_T c19_y;
  real_T c19_b_a;
  real_T c19_b_y;
  real_T c19_d3;
  int32_T c19_i2;
  int32_T c19_i3;
  real_T c19_x;
  real_T c19_b_x;
  real_T c19_c_x;
  real_T c19_d_x;
  real_T c19_e_x;
  real_T c19_f_x;
  real_T c19_c_a;
  real_T c19_b_b;
  real_T c19_c_y;
  int32_T c19_i4;
  int32_T c19_i5;
  int32_T c19_i6;
  int32_T c19_i7;
  real_T c19_d_a[6];
  int32_T c19_i8;
  real_T c19_c_b[6];
  int32_T c19_i9;
  int32_T c19_i10;
  int32_T c19_i11;
  int32_T c19_i12;
  real_T c19_d_y[4];
  int32_T c19_i13;
  int32_T c19_i14;
  int32_T c19_i15;
  real_T c19_e_y[4];
  int32_T c19_i16;
  int32_T c19_i17;
  int32_T c19_i18;
  int32_T c19_i19;
  real_T c19_b_T[6];
  int32_T c19_i20;
  real_T c19_d_b[3];
  int32_T c19_i21;
  real_T c19_f_y[2];
  int32_T c19_i22;
  int32_T c19_i23;
  int32_T c19_i24;
  real_T c19_g_x;
  real_T c19_h_x;
  real_T c19_i_x;
  real_T c19_g_y;
  real_T c19_j_x;
  real_T c19_k_x;
  real_T c19_h_y;
  real_T c19_d;
  real_T c19_l_x;
  real_T c19_m_x;
  real_T c19_n_x;
  real_T c19_i_y;
  real_T c19_o_x;
  real_T c19_p_x;
  real_T c19_j_y;
  real_T c19_b_d;
  int32_T c19_r1;
  int32_T c19_r2;
  real_T c19_q_x;
  real_T c19_k_y;
  real_T c19_a21;
  real_T c19_e_a;
  real_T c19_e_b;
  real_T c19_l_y;
  real_T c19_a22;
  real_T c19_f_a;
  real_T c19_f_b;
  real_T c19_m_y;
  real_T c19_r_x;
  real_T c19_n_y;
  real_T c19_z;
  real_T c19_g_a;
  real_T c19_g_b;
  real_T c19_o_y;
  real_T c19_s_x;
  real_T c19_p_y;
  real_T c19_b_z;
  real_T c19_h_a;
  real_T c19_h_b;
  real_T c19_q_y;
  real_T c19_A;
  real_T c19_B;
  real_T c19_t_x;
  real_T c19_r_y;
  real_T c19_u_x;
  real_T c19_s_y;
  real_T c19_t_y;
  real_T *c19_b_st;
  real_T *c19_b_th;
  real_T *c19_b_delta;
  real_T *c19_b_psi_dot;
  real_T *c19_b_beta;
  real_T *c19_b_v;
  real_T (*c19_b_tau)[3];
  boolean_T guard1 = FALSE;
  c19_b_st = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c19_b_th = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c19_b_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c19_b_tau = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c19_b_psi_dot = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c19_b_beta = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c19_b_v = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 8U, chartInstance->c19_sfEvent);
  c19_hoistedGlobal = *c19_b_v;
  c19_b_hoistedGlobal = *c19_b_beta;
  c19_c_hoistedGlobal = *c19_b_psi_dot;
  c19_d_hoistedGlobal = chartInstance->c19_l_front;
  c19_e_hoistedGlobal = *c19_b_delta;
  c19_f_hoistedGlobal = chartInstance->c19_m_car;
  c19_g_hoistedGlobal = chartInstance->c19_mu;
  c19_v = c19_hoistedGlobal;
  c19_beta = c19_b_hoistedGlobal;
  c19_psi_dot = c19_c_hoistedGlobal;
  c19_b_l_front = c19_d_hoistedGlobal;
  for (c19_i1 = 0; c19_i1 < 3; c19_i1++) {
    c19_tau[c19_i1] = (*c19_b_tau)[c19_i1];
  }

  c19_delta = c19_e_hoistedGlobal;
  c19_b_m_car = c19_f_hoistedGlobal;
  c19_b_mu = c19_g_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 16U, 16U, c19_debug_family_names,
    c19_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c19_K, 0U, c19_e_sf_marshallOut,
    c19_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c19_T, 1U, c19_d_sf_marshallOut,
    c19_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c19_u, 2U, c19_c_sf_marshallOut,
    c19_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c19_alpha, 3U, c19_sf_marshallOut,
    c19_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c19_nargin, 4U, c19_sf_marshallOut,
    c19_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c19_nargout, 5U, c19_sf_marshallOut,
    c19_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c19_v, 6U, c19_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c19_beta, 7U, c19_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c19_psi_dot, 8U, c19_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c19_b_l_front, 9U,
    c19_sf_marshallOut, c19_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c19_tau, 10U, c19_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c19_delta, 11U, c19_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c19_b_m_car, 12U, c19_sf_marshallOut,
    c19_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c19_b_mu, 13U, c19_sf_marshallOut,
    c19_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c19_th, 14U, c19_sf_marshallOut,
    c19_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c19_st, 15U, c19_sf_marshallOut,
    c19_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c19_sfEvent, 3);
  c19_a = c19_b_mu;
  c19_b = c19_b_m_car;
  c19_y = c19_a * c19_b;
  c19_b_a = c19_y;
  c19_b_y = c19_b_a * 9.81;
  c19_d3 = c19_mrdivide(chartInstance, c19_b_y, 25.0);
  c19_K[0] = c19_d3;
  c19_K[2] = 0.0;
  c19_i2 = 0;
  for (c19_i3 = 0; c19_i3 < 2; c19_i3++) {
    c19_K[c19_i2 + 1] = 12.0 * (real_T)c19_i3;
    c19_i2 += 2;
  }

  _SFD_EML_CALL(0U, chartInstance->c19_sfEvent, 6);
  c19_x = c19_delta;
  c19_b_x = c19_x;
  c19_b_x = muDoubleScalarSin(c19_b_x);
  c19_c_x = c19_delta;
  c19_d_x = c19_c_x;
  c19_d_x = muDoubleScalarCos(c19_d_x);
  c19_e_x = c19_delta;
  c19_f_x = c19_e_x;
  c19_f_x = muDoubleScalarCos(c19_f_x);
  c19_c_a = c19_b_l_front;
  c19_b_b = c19_f_x;
  c19_c_y = c19_c_a * c19_b_b;
  c19_T[0] = 1.0;
  c19_T[3] = -c19_b_x;
  c19_T[1] = 0.0;
  c19_T[4] = c19_d_x;
  c19_T[2] = 0.0;
  c19_T[5] = c19_c_y;
  _SFD_EML_CALL(0U, chartInstance->c19_sfEvent, 10);
  c19_i4 = 0;
  for (c19_i5 = 0; c19_i5 < 3; c19_i5++) {
    c19_i6 = 0;
    for (c19_i7 = 0; c19_i7 < 2; c19_i7++) {
      c19_d_a[c19_i7 + c19_i4] = c19_T[c19_i6 + c19_i5];
      c19_i6 += 3;
    }

    c19_i4 += 2;
  }

  for (c19_i8 = 0; c19_i8 < 6; c19_i8++) {
    c19_c_b[c19_i8] = c19_T[c19_i8];
  }

  c19_eml_scalar_eg(chartInstance);
  c19_eml_scalar_eg(chartInstance);
  for (c19_i9 = 0; c19_i9 < 2; c19_i9++) {
    c19_i10 = 0;
    c19_i11 = 0;
    for (c19_i12 = 0; c19_i12 < 2; c19_i12++) {
      c19_d_y[c19_i10 + c19_i9] = 0.0;
      c19_i13 = 0;
      for (c19_i14 = 0; c19_i14 < 3; c19_i14++) {
        c19_d_y[c19_i10 + c19_i9] += c19_d_a[c19_i13 + c19_i9] * c19_c_b[c19_i14
          + c19_i11];
        c19_i13 += 2;
      }

      c19_i10 += 2;
      c19_i11 += 3;
    }
  }

  for (c19_i15 = 0; c19_i15 < 4; c19_i15++) {
    c19_e_y[c19_i15] = c19_d_y[c19_i15];
  }

  c19_i16 = 0;
  for (c19_i17 = 0; c19_i17 < 3; c19_i17++) {
    c19_i18 = 0;
    for (c19_i19 = 0; c19_i19 < 2; c19_i19++) {
      c19_b_T[c19_i19 + c19_i16] = c19_T[c19_i18 + c19_i17];
      c19_i18 += 3;
    }

    c19_i16 += 2;
  }

  c19_mldivide(chartInstance, c19_e_y, c19_b_T, c19_d_a);
  for (c19_i20 = 0; c19_i20 < 3; c19_i20++) {
    c19_d_b[c19_i20] = c19_tau[c19_i20];
  }

  c19_b_eml_scalar_eg(chartInstance);
  c19_b_eml_scalar_eg(chartInstance);
  for (c19_i21 = 0; c19_i21 < 2; c19_i21++) {
    c19_f_y[c19_i21] = 0.0;
    c19_i22 = 0;
    for (c19_i23 = 0; c19_i23 < 3; c19_i23++) {
      c19_f_y[c19_i21] += c19_d_a[c19_i22 + c19_i21] * c19_d_b[c19_i23];
      c19_i22 += 2;
    }
  }

  for (c19_i24 = 0; c19_i24 < 4; c19_i24++) {
    c19_d_y[c19_i24] = c19_K[c19_i24];
  }

  c19_g_x = c19_d_y[1];
  c19_h_x = c19_g_x;
  c19_i_x = c19_h_x;
  c19_g_y = muDoubleScalarAbs(c19_i_x);
  c19_j_x = 0.0;
  c19_k_x = c19_j_x;
  c19_h_y = muDoubleScalarAbs(c19_k_x);
  c19_d = c19_g_y + c19_h_y;
  c19_l_x = c19_d_y[0];
  c19_m_x = c19_l_x;
  c19_n_x = c19_m_x;
  c19_i_y = muDoubleScalarAbs(c19_n_x);
  c19_o_x = 0.0;
  c19_p_x = c19_o_x;
  c19_j_y = muDoubleScalarAbs(c19_p_x);
  c19_b_d = c19_i_y + c19_j_y;
  if (c19_d > c19_b_d) {
    c19_r1 = 2;
    c19_r2 = 1;
  } else {
    c19_r1 = 1;
    c19_r2 = 2;
  }

  c19_q_x = c19_d_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c19_r2), 1, 2, 1, 0) - 1];
  c19_k_y = c19_d_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c19_r1), 1, 2, 1, 0) - 1];
  c19_a21 = c19_q_x / c19_k_y;
  c19_e_a = c19_a21;
  c19_e_b = c19_d_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c19_r1), 1, 2, 1, 0) + 1];
  c19_l_y = c19_e_a * c19_e_b;
  c19_a22 = c19_d_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c19_r2), 1, 2, 1, 0) + 1] - c19_l_y;
  guard1 = FALSE;
  if (c19_a22 == 0.0) {
    guard1 = TRUE;
  } else {
    if (c19_d_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c19_r1), 1, 2, 1, 0) - 1] == 0.0) {
      guard1 = TRUE;
    }
  }

  if (guard1 == TRUE) {
    c19_eml_warning(chartInstance);
  }

  c19_f_a = c19_f_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c19_r1), 1, 2, 1, 0) - 1];
  c19_f_b = c19_a21;
  c19_m_y = c19_f_a * c19_f_b;
  c19_r_x = c19_f_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c19_r2), 1, 2, 1, 0) - 1] - c19_m_y;
  c19_n_y = c19_a22;
  c19_z = c19_r_x / c19_n_y;
  c19_u[1] = c19_z;
  c19_g_a = c19_u[1];
  c19_g_b = c19_d_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c19_r1), 1, 2, 1, 0) + 1];
  c19_o_y = c19_g_a * c19_g_b;
  c19_s_x = c19_f_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c19_r1), 1, 2, 1, 0) - 1] - c19_o_y;
  c19_p_y = c19_d_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c19_r1), 1, 2, 1, 0) - 1];
  c19_b_z = c19_s_x / c19_p_y;
  c19_u[0] = c19_b_z;
  _SFD_EML_CALL(0U, chartInstance->c19_sfEvent, 12);
  c19_th = c19_u[0];
  _SFD_EML_CALL(0U, chartInstance->c19_sfEvent, 14);
  c19_alpha = c19_u[1];
  _SFD_EML_CALL(0U, chartInstance->c19_sfEvent, 15);
  c19_h_a = c19_b_l_front;
  c19_h_b = c19_psi_dot;
  c19_q_y = c19_h_a * c19_h_b;
  c19_A = c19_q_y;
  c19_B = c19_v;
  c19_t_x = c19_A;
  c19_r_y = c19_B;
  c19_u_x = c19_t_x;
  c19_s_y = c19_r_y;
  c19_t_y = c19_u_x / c19_s_y;
  c19_st = (c19_alpha + c19_beta) + c19_t_y;
  _SFD_EML_CALL(0U, chartInstance->c19_sfEvent, -15);
  sf_debug_symbol_scope_pop();
  *c19_b_th = c19_th;
  *c19_b_st = c19_st;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 8U, chartInstance->c19_sfEvent);
}

static void initSimStructsc19_carsim(SFc19_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c19_machineNumber, uint32_T
  c19_chartNumber)
{
}

static const mxArray *c19_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData)
{
  const mxArray *c19_mxArrayOutData = NULL;
  real_T c19_u;
  const mxArray *c19_y = NULL;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_mxArrayOutData = NULL;
  c19_u = *(real_T *)c19_inData;
  c19_y = NULL;
  sf_mex_assign(&c19_y, sf_mex_create("y", &c19_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c19_mxArrayOutData, c19_y, FALSE);
  return c19_mxArrayOutData;
}

static real_T c19_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_st, const char_T *c19_identifier)
{
  real_T c19_y;
  emlrtMsgIdentifier c19_thisId;
  c19_thisId.fIdentifier = c19_identifier;
  c19_thisId.fParent = NULL;
  c19_y = c19_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c19_st), &c19_thisId);
  sf_mex_destroy(&c19_st);
  return c19_y;
}

static real_T c19_b_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId)
{
  real_T c19_y;
  real_T c19_d4;
  sf_mex_import(c19_parentId, sf_mex_dup(c19_u), &c19_d4, 1, 0, 0U, 0, 0U, 0);
  c19_y = c19_d4;
  sf_mex_destroy(&c19_u);
  return c19_y;
}

static void c19_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData)
{
  const mxArray *c19_st;
  const char_T *c19_identifier;
  emlrtMsgIdentifier c19_thisId;
  real_T c19_y;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_st = sf_mex_dup(c19_mxArrayInData);
  c19_identifier = c19_varName;
  c19_thisId.fIdentifier = c19_identifier;
  c19_thisId.fParent = NULL;
  c19_y = c19_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c19_st), &c19_thisId);
  sf_mex_destroy(&c19_st);
  *(real_T *)c19_outData = c19_y;
  sf_mex_destroy(&c19_mxArrayInData);
}

static const mxArray *c19_b_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData)
{
  const mxArray *c19_mxArrayOutData = NULL;
  int32_T c19_i25;
  real_T c19_b_inData[3];
  int32_T c19_i26;
  real_T c19_u[3];
  const mxArray *c19_y = NULL;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_mxArrayOutData = NULL;
  for (c19_i25 = 0; c19_i25 < 3; c19_i25++) {
    c19_b_inData[c19_i25] = (*(real_T (*)[3])c19_inData)[c19_i25];
  }

  for (c19_i26 = 0; c19_i26 < 3; c19_i26++) {
    c19_u[c19_i26] = c19_b_inData[c19_i26];
  }

  c19_y = NULL;
  sf_mex_assign(&c19_y, sf_mex_create("y", c19_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c19_mxArrayOutData, c19_y, FALSE);
  return c19_mxArrayOutData;
}

static const mxArray *c19_c_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData)
{
  const mxArray *c19_mxArrayOutData = NULL;
  int32_T c19_i27;
  real_T c19_b_inData[2];
  int32_T c19_i28;
  real_T c19_u[2];
  const mxArray *c19_y = NULL;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_mxArrayOutData = NULL;
  for (c19_i27 = 0; c19_i27 < 2; c19_i27++) {
    c19_b_inData[c19_i27] = (*(real_T (*)[2])c19_inData)[c19_i27];
  }

  for (c19_i28 = 0; c19_i28 < 2; c19_i28++) {
    c19_u[c19_i28] = c19_b_inData[c19_i28];
  }

  c19_y = NULL;
  sf_mex_assign(&c19_y, sf_mex_create("y", c19_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c19_mxArrayOutData, c19_y, FALSE);
  return c19_mxArrayOutData;
}

static void c19_c_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId, real_T c19_y[2])
{
  real_T c19_dv0[2];
  int32_T c19_i29;
  sf_mex_import(c19_parentId, sf_mex_dup(c19_u), c19_dv0, 1, 0, 0U, 1, 0U, 1, 2);
  for (c19_i29 = 0; c19_i29 < 2; c19_i29++) {
    c19_y[c19_i29] = c19_dv0[c19_i29];
  }

  sf_mex_destroy(&c19_u);
}

static void c19_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData)
{
  const mxArray *c19_u;
  const char_T *c19_identifier;
  emlrtMsgIdentifier c19_thisId;
  real_T c19_y[2];
  int32_T c19_i30;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_u = sf_mex_dup(c19_mxArrayInData);
  c19_identifier = c19_varName;
  c19_thisId.fIdentifier = c19_identifier;
  c19_thisId.fParent = NULL;
  c19_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c19_u), &c19_thisId, c19_y);
  sf_mex_destroy(&c19_u);
  for (c19_i30 = 0; c19_i30 < 2; c19_i30++) {
    (*(real_T (*)[2])c19_outData)[c19_i30] = c19_y[c19_i30];
  }

  sf_mex_destroy(&c19_mxArrayInData);
}

static const mxArray *c19_d_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData)
{
  const mxArray *c19_mxArrayOutData = NULL;
  int32_T c19_i31;
  int32_T c19_i32;
  int32_T c19_i33;
  real_T c19_b_inData[6];
  int32_T c19_i34;
  int32_T c19_i35;
  int32_T c19_i36;
  real_T c19_u[6];
  const mxArray *c19_y = NULL;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_mxArrayOutData = NULL;
  c19_i31 = 0;
  for (c19_i32 = 0; c19_i32 < 2; c19_i32++) {
    for (c19_i33 = 0; c19_i33 < 3; c19_i33++) {
      c19_b_inData[c19_i33 + c19_i31] = (*(real_T (*)[6])c19_inData)[c19_i33 +
        c19_i31];
    }

    c19_i31 += 3;
  }

  c19_i34 = 0;
  for (c19_i35 = 0; c19_i35 < 2; c19_i35++) {
    for (c19_i36 = 0; c19_i36 < 3; c19_i36++) {
      c19_u[c19_i36 + c19_i34] = c19_b_inData[c19_i36 + c19_i34];
    }

    c19_i34 += 3;
  }

  c19_y = NULL;
  sf_mex_assign(&c19_y, sf_mex_create("y", c19_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c19_mxArrayOutData, c19_y, FALSE);
  return c19_mxArrayOutData;
}

static void c19_d_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId, real_T c19_y[6])
{
  real_T c19_dv1[6];
  int32_T c19_i37;
  sf_mex_import(c19_parentId, sf_mex_dup(c19_u), c19_dv1, 1, 0, 0U, 1, 0U, 2, 3,
                2);
  for (c19_i37 = 0; c19_i37 < 6; c19_i37++) {
    c19_y[c19_i37] = c19_dv1[c19_i37];
  }

  sf_mex_destroy(&c19_u);
}

static void c19_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData)
{
  const mxArray *c19_T;
  const char_T *c19_identifier;
  emlrtMsgIdentifier c19_thisId;
  real_T c19_y[6];
  int32_T c19_i38;
  int32_T c19_i39;
  int32_T c19_i40;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_T = sf_mex_dup(c19_mxArrayInData);
  c19_identifier = c19_varName;
  c19_thisId.fIdentifier = c19_identifier;
  c19_thisId.fParent = NULL;
  c19_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c19_T), &c19_thisId, c19_y);
  sf_mex_destroy(&c19_T);
  c19_i38 = 0;
  for (c19_i39 = 0; c19_i39 < 2; c19_i39++) {
    for (c19_i40 = 0; c19_i40 < 3; c19_i40++) {
      (*(real_T (*)[6])c19_outData)[c19_i40 + c19_i38] = c19_y[c19_i40 + c19_i38];
    }

    c19_i38 += 3;
  }

  sf_mex_destroy(&c19_mxArrayInData);
}

static const mxArray *c19_e_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData)
{
  const mxArray *c19_mxArrayOutData = NULL;
  int32_T c19_i41;
  int32_T c19_i42;
  int32_T c19_i43;
  real_T c19_b_inData[4];
  int32_T c19_i44;
  int32_T c19_i45;
  int32_T c19_i46;
  real_T c19_u[4];
  const mxArray *c19_y = NULL;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_mxArrayOutData = NULL;
  c19_i41 = 0;
  for (c19_i42 = 0; c19_i42 < 2; c19_i42++) {
    for (c19_i43 = 0; c19_i43 < 2; c19_i43++) {
      c19_b_inData[c19_i43 + c19_i41] = (*(real_T (*)[4])c19_inData)[c19_i43 +
        c19_i41];
    }

    c19_i41 += 2;
  }

  c19_i44 = 0;
  for (c19_i45 = 0; c19_i45 < 2; c19_i45++) {
    for (c19_i46 = 0; c19_i46 < 2; c19_i46++) {
      c19_u[c19_i46 + c19_i44] = c19_b_inData[c19_i46 + c19_i44];
    }

    c19_i44 += 2;
  }

  c19_y = NULL;
  sf_mex_assign(&c19_y, sf_mex_create("y", c19_u, 0, 0U, 1U, 0U, 2, 2, 2), FALSE);
  sf_mex_assign(&c19_mxArrayOutData, c19_y, FALSE);
  return c19_mxArrayOutData;
}

static void c19_e_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId, real_T c19_y[4])
{
  real_T c19_dv2[4];
  int32_T c19_i47;
  sf_mex_import(c19_parentId, sf_mex_dup(c19_u), c19_dv2, 1, 0, 0U, 1, 0U, 2, 2,
                2);
  for (c19_i47 = 0; c19_i47 < 4; c19_i47++) {
    c19_y[c19_i47] = c19_dv2[c19_i47];
  }

  sf_mex_destroy(&c19_u);
}

static void c19_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData)
{
  const mxArray *c19_K;
  const char_T *c19_identifier;
  emlrtMsgIdentifier c19_thisId;
  real_T c19_y[4];
  int32_T c19_i48;
  int32_T c19_i49;
  int32_T c19_i50;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_K = sf_mex_dup(c19_mxArrayInData);
  c19_identifier = c19_varName;
  c19_thisId.fIdentifier = c19_identifier;
  c19_thisId.fParent = NULL;
  c19_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c19_K), &c19_thisId, c19_y);
  sf_mex_destroy(&c19_K);
  c19_i48 = 0;
  for (c19_i49 = 0; c19_i49 < 2; c19_i49++) {
    for (c19_i50 = 0; c19_i50 < 2; c19_i50++) {
      (*(real_T (*)[4])c19_outData)[c19_i50 + c19_i48] = c19_y[c19_i50 + c19_i48];
    }

    c19_i48 += 2;
  }

  sf_mex_destroy(&c19_mxArrayInData);
}

const mxArray *sf_c19_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c19_nameCaptureInfo;
  c19_ResolvedFunctionInfo c19_info[19];
  const mxArray *c19_m0 = NULL;
  int32_T c19_i51;
  c19_ResolvedFunctionInfo *c19_r0;
  c19_nameCaptureInfo = NULL;
  c19_nameCaptureInfo = NULL;
  c19_info_helper(c19_info);
  sf_mex_assign(&c19_m0, sf_mex_createstruct("nameCaptureInfo", 1, 19), FALSE);
  for (c19_i51 = 0; c19_i51 < 19; c19_i51++) {
    c19_r0 = &c19_info[c19_i51];
    sf_mex_addfield(c19_m0, sf_mex_create("nameCaptureInfo", c19_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c19_r0->context)), "context", "nameCaptureInfo",
                    c19_i51);
    sf_mex_addfield(c19_m0, sf_mex_create("nameCaptureInfo", c19_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c19_r0->name)), "name", "nameCaptureInfo",
                    c19_i51);
    sf_mex_addfield(c19_m0, sf_mex_create("nameCaptureInfo",
      c19_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c19_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c19_i51);
    sf_mex_addfield(c19_m0, sf_mex_create("nameCaptureInfo", c19_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c19_r0->resolved)), "resolved",
                    "nameCaptureInfo", c19_i51);
    sf_mex_addfield(c19_m0, sf_mex_create("nameCaptureInfo", &c19_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c19_i51);
    sf_mex_addfield(c19_m0, sf_mex_create("nameCaptureInfo", &c19_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c19_i51);
    sf_mex_addfield(c19_m0, sf_mex_create("nameCaptureInfo",
      &c19_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c19_i51);
    sf_mex_addfield(c19_m0, sf_mex_create("nameCaptureInfo",
      &c19_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c19_i51);
  }

  sf_mex_assign(&c19_nameCaptureInfo, c19_m0, FALSE);
  return c19_nameCaptureInfo;
}

static void c19_info_helper(c19_ResolvedFunctionInfo c19_info[19])
{
  c19_info[0].context = "";
  c19_info[0].name = "mtimes";
  c19_info[0].dominantType = "double";
  c19_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c19_info[0].fileTimeLo = 1289519692U;
  c19_info[0].fileTimeHi = 0U;
  c19_info[0].mFileTimeLo = 0U;
  c19_info[0].mFileTimeHi = 0U;
  c19_info[1].context = "";
  c19_info[1].name = "mrdivide";
  c19_info[1].dominantType = "double";
  c19_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c19_info[1].fileTimeLo = 1310137456U;
  c19_info[1].fileTimeHi = 0U;
  c19_info[1].mFileTimeLo = 1289519692U;
  c19_info[1].mFileTimeHi = 0U;
  c19_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c19_info[2].name = "rdivide";
  c19_info[2].dominantType = "double";
  c19_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c19_info[2].fileTimeLo = 1286818844U;
  c19_info[2].fileTimeHi = 0U;
  c19_info[2].mFileTimeLo = 0U;
  c19_info[2].mFileTimeHi = 0U;
  c19_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c19_info[3].name = "eml_div";
  c19_info[3].dominantType = "double";
  c19_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c19_info[3].fileTimeLo = 1305318000U;
  c19_info[3].fileTimeHi = 0U;
  c19_info[3].mFileTimeLo = 0U;
  c19_info[3].mFileTimeHi = 0U;
  c19_info[4].context = "";
  c19_info[4].name = "sin";
  c19_info[4].dominantType = "double";
  c19_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c19_info[4].fileTimeLo = 1286818750U;
  c19_info[4].fileTimeHi = 0U;
  c19_info[4].mFileTimeLo = 0U;
  c19_info[4].mFileTimeHi = 0U;
  c19_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c19_info[5].name = "eml_scalar_sin";
  c19_info[5].dominantType = "double";
  c19_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c19_info[5].fileTimeLo = 1286818736U;
  c19_info[5].fileTimeHi = 0U;
  c19_info[5].mFileTimeLo = 0U;
  c19_info[5].mFileTimeHi = 0U;
  c19_info[6].context = "";
  c19_info[6].name = "cos";
  c19_info[6].dominantType = "double";
  c19_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c19_info[6].fileTimeLo = 1286818706U;
  c19_info[6].fileTimeHi = 0U;
  c19_info[6].mFileTimeLo = 0U;
  c19_info[6].mFileTimeHi = 0U;
  c19_info[7].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c19_info[7].name = "eml_scalar_cos";
  c19_info[7].dominantType = "double";
  c19_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c19_info[7].fileTimeLo = 1286818722U;
  c19_info[7].fileTimeHi = 0U;
  c19_info[7].mFileTimeLo = 0U;
  c19_info[7].mFileTimeHi = 0U;
  c19_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c19_info[8].name = "eml_index_class";
  c19_info[8].dominantType = "";
  c19_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c19_info[8].fileTimeLo = 1286818778U;
  c19_info[8].fileTimeHi = 0U;
  c19_info[8].mFileTimeLo = 0U;
  c19_info[8].mFileTimeHi = 0U;
  c19_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c19_info[9].name = "eml_scalar_eg";
  c19_info[9].dominantType = "double";
  c19_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c19_info[9].fileTimeLo = 1286818796U;
  c19_info[9].fileTimeHi = 0U;
  c19_info[9].mFileTimeLo = 0U;
  c19_info[9].mFileTimeHi = 0U;
  c19_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c19_info[10].name = "eml_xgemm";
  c19_info[10].dominantType = "int32";
  c19_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c19_info[10].fileTimeLo = 1299076772U;
  c19_info[10].fileTimeHi = 0U;
  c19_info[10].mFileTimeLo = 0U;
  c19_info[10].mFileTimeHi = 0U;
  c19_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c19_info[11].name = "eml_blas_inline";
  c19_info[11].dominantType = "";
  c19_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c19_info[11].fileTimeLo = 1299076768U;
  c19_info[11].fileTimeHi = 0U;
  c19_info[11].mFileTimeLo = 0U;
  c19_info[11].mFileTimeHi = 0U;
  c19_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c19_info[12].name = "eml_refblas_xgemm";
  c19_info[12].dominantType = "int32";
  c19_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c19_info[12].fileTimeLo = 1299076774U;
  c19_info[12].fileTimeHi = 0U;
  c19_info[12].mFileTimeLo = 0U;
  c19_info[12].mFileTimeHi = 0U;
  c19_info[13].context = "";
  c19_info[13].name = "mldivide";
  c19_info[13].dominantType = "double";
  c19_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c19_info[13].fileTimeLo = 1310137456U;
  c19_info[13].fileTimeHi = 0U;
  c19_info[13].mFileTimeLo = 1289519690U;
  c19_info[13].mFileTimeHi = 0U;
  c19_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c19_info[14].name = "eml_lusolve";
  c19_info[14].dominantType = "double";
  c19_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m";
  c19_info[14].fileTimeLo = 1305318000U;
  c19_info[14].fileTimeHi = 0U;
  c19_info[14].mFileTimeLo = 0U;
  c19_info[14].mFileTimeHi = 0U;
  c19_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve2x2";
  c19_info[15].name = "eml_xcabs1";
  c19_info[15].dominantType = "double";
  c19_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c19_info[15].fileTimeLo = 1286818706U;
  c19_info[15].fileTimeHi = 0U;
  c19_info[15].mFileTimeLo = 0U;
  c19_info[15].mFileTimeHi = 0U;
  c19_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c19_info[16].name = "abs";
  c19_info[16].dominantType = "double";
  c19_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c19_info[16].fileTimeLo = 1286818694U;
  c19_info[16].fileTimeHi = 0U;
  c19_info[16].mFileTimeLo = 0U;
  c19_info[16].mFileTimeHi = 0U;
  c19_info[17].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c19_info[17].name = "eml_scalar_abs";
  c19_info[17].dominantType = "double";
  c19_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c19_info[17].fileTimeLo = 1286818712U;
  c19_info[17].fileTimeHi = 0U;
  c19_info[17].mFileTimeLo = 0U;
  c19_info[17].mFileTimeHi = 0U;
  c19_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!warn_singular";
  c19_info[18].name = "eml_warning";
  c19_info[18].dominantType = "char";
  c19_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c19_info[18].fileTimeLo = 1286818802U;
  c19_info[18].fileTimeHi = 0U;
  c19_info[18].mFileTimeLo = 0U;
  c19_info[18].mFileTimeHi = 0U;
}

static real_T c19_mrdivide(SFc19_carsimInstanceStruct *chartInstance, real_T
  c19_A, real_T c19_B)
{
  real_T c19_x;
  real_T c19_b_y;
  real_T c19_b_x;
  real_T c19_c_y;
  c19_x = c19_A;
  c19_b_y = c19_B;
  c19_b_x = c19_x;
  c19_c_y = c19_b_y;
  return c19_b_x / c19_c_y;
}

static void c19_eml_scalar_eg(SFc19_carsimInstanceStruct *chartInstance)
{
}

static void c19_mldivide(SFc19_carsimInstanceStruct *chartInstance, real_T
  c19_A[4], real_T c19_B[6], real_T c19_Y[6])
{
  real_T c19_x;
  real_T c19_b_x;
  real_T c19_c_x;
  real_T c19_y;
  real_T c19_d_x;
  real_T c19_e_x;
  real_T c19_b_y;
  real_T c19_d;
  real_T c19_f_x;
  real_T c19_g_x;
  real_T c19_h_x;
  real_T c19_c_y;
  real_T c19_i_x;
  real_T c19_j_x;
  real_T c19_d_y;
  real_T c19_b_d;
  int32_T c19_r1;
  int32_T c19_r2;
  real_T c19_k_x;
  real_T c19_e_y;
  real_T c19_a21;
  real_T c19_a;
  real_T c19_b;
  real_T c19_f_y;
  real_T c19_a22;
  int32_T c19_k;
  int32_T c19_b_k;
  real_T c19_b_a;
  real_T c19_b_b;
  real_T c19_g_y;
  real_T c19_l_x;
  real_T c19_h_y;
  real_T c19_z;
  real_T c19_c_a;
  real_T c19_c_b;
  real_T c19_i_y;
  real_T c19_m_x;
  real_T c19_j_y;
  real_T c19_b_z;
  boolean_T guard1 = FALSE;
  c19_x = c19_A[1];
  c19_b_x = c19_x;
  c19_c_x = c19_b_x;
  c19_y = muDoubleScalarAbs(c19_c_x);
  c19_d_x = 0.0;
  c19_e_x = c19_d_x;
  c19_b_y = muDoubleScalarAbs(c19_e_x);
  c19_d = c19_y + c19_b_y;
  c19_f_x = c19_A[0];
  c19_g_x = c19_f_x;
  c19_h_x = c19_g_x;
  c19_c_y = muDoubleScalarAbs(c19_h_x);
  c19_i_x = 0.0;
  c19_j_x = c19_i_x;
  c19_d_y = muDoubleScalarAbs(c19_j_x);
  c19_b_d = c19_c_y + c19_d_y;
  if (c19_d > c19_b_d) {
    c19_r1 = 2;
    c19_r2 = 1;
  } else {
    c19_r1 = 1;
    c19_r2 = 2;
  }

  c19_k_x = c19_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c19_r2), 1, 2, 1, 0) - 1];
  c19_e_y = c19_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c19_r1), 1, 2, 1, 0) - 1];
  c19_a21 = c19_k_x / c19_e_y;
  c19_a = c19_a21;
  c19_b = c19_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c19_r1), 1, 2, 1, 0) + 1];
  c19_f_y = c19_a * c19_b;
  c19_a22 = c19_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c19_r2), 1, 2, 1, 0) + 1] - c19_f_y;
  guard1 = FALSE;
  if (c19_a22 == 0.0) {
    guard1 = TRUE;
  } else {
    if (c19_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c19_r1), 1, 2, 1, 0) - 1] == 0.0) {
      guard1 = TRUE;
    }
  }

  if (guard1 == TRUE) {
    c19_eml_warning(chartInstance);
  }

  for (c19_k = 1; c19_k < 4; c19_k++) {
    c19_b_k = c19_k;
    c19_b_a = c19_B[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK
                      ("", (real_T)c19_r1), 1, 2, 1, 0) +
                     ((_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", (real_T)c19_b_k), 1, 3, 2, 0) - 1) << 1)) - 1];
    c19_b_b = c19_a21;
    c19_g_y = c19_b_a * c19_b_b;
    c19_l_x = c19_B[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK
                      ("", (real_T)c19_r2), 1, 2, 1, 0) +
                     ((_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", (real_T)c19_b_k), 1, 3, 2, 0) - 1) << 1)) - 1] -
      c19_g_y;
    c19_h_y = c19_a22;
    c19_z = c19_l_x / c19_h_y;
    c19_Y[1 + ((_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
                  (real_T)c19_b_k), 1, 3, 2, 0) - 1) << 1)] = c19_z;
    c19_c_a = c19_Y[1 + ((_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", (real_T)c19_b_k), 1, 3, 2, 0) - 1) << 1)];
    c19_c_b = c19_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
      "", (real_T)c19_r1), 1, 2, 1, 0) + 1];
    c19_i_y = c19_c_a * c19_c_b;
    c19_m_x = c19_B[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK
                      ("", (real_T)c19_r1), 1, 2, 1, 0) +
                     ((_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", (real_T)c19_b_k), 1, 3, 2, 0) - 1) << 1)) - 1] -
      c19_i_y;
    c19_j_y = c19_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
      "", (real_T)c19_r1), 1, 2, 1, 0) - 1];
    c19_b_z = c19_m_x / c19_j_y;
    c19_Y[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
             (real_T)c19_b_k), 1, 3, 2, 0) - 1) << 1] = c19_b_z;
  }
}

static void c19_eml_warning(SFc19_carsimInstanceStruct *chartInstance)
{
  int32_T c19_i52;
  static char_T c19_varargin_1[27] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'i', 'n', 'g', 'u', 'l', 'a', 'r', 'M', 'a',
    't', 'r', 'i', 'x' };

  char_T c19_u[27];
  const mxArray *c19_y = NULL;
  for (c19_i52 = 0; c19_i52 < 27; c19_i52++) {
    c19_u[c19_i52] = c19_varargin_1[c19_i52];
  }

  c19_y = NULL;
  sf_mex_assign(&c19_y, sf_mex_create("y", c19_u, 10, 0U, 1U, 0U, 2, 1, 27),
                FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U,
    14, c19_y));
}

static void c19_b_eml_scalar_eg(SFc19_carsimInstanceStruct *chartInstance)
{
}

static const mxArray *c19_f_sf_marshallOut(void *chartInstanceVoid, void
  *c19_inData)
{
  const mxArray *c19_mxArrayOutData = NULL;
  int32_T c19_u;
  const mxArray *c19_y = NULL;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_mxArrayOutData = NULL;
  c19_u = *(int32_T *)c19_inData;
  c19_y = NULL;
  sf_mex_assign(&c19_y, sf_mex_create("y", &c19_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c19_mxArrayOutData, c19_y, FALSE);
  return c19_mxArrayOutData;
}

static int32_T c19_f_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId)
{
  int32_T c19_y;
  int32_T c19_i53;
  sf_mex_import(c19_parentId, sf_mex_dup(c19_u), &c19_i53, 1, 6, 0U, 0, 0U, 0);
  c19_y = c19_i53;
  sf_mex_destroy(&c19_u);
  return c19_y;
}

static void c19_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c19_mxArrayInData, const char_T *c19_varName, void *c19_outData)
{
  const mxArray *c19_b_sfEvent;
  const char_T *c19_identifier;
  emlrtMsgIdentifier c19_thisId;
  int32_T c19_y;
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)chartInstanceVoid;
  c19_b_sfEvent = sf_mex_dup(c19_mxArrayInData);
  c19_identifier = c19_varName;
  c19_thisId.fIdentifier = c19_identifier;
  c19_thisId.fParent = NULL;
  c19_y = c19_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c19_b_sfEvent),
    &c19_thisId);
  sf_mex_destroy(&c19_b_sfEvent);
  *(int32_T *)c19_outData = c19_y;
  sf_mex_destroy(&c19_mxArrayInData);
}

static uint8_T c19_g_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_b_is_active_c19_carsim, const char_T *c19_identifier)
{
  uint8_T c19_y;
  emlrtMsgIdentifier c19_thisId;
  c19_thisId.fIdentifier = c19_identifier;
  c19_thisId.fParent = NULL;
  c19_y = c19_h_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c19_b_is_active_c19_carsim), &c19_thisId);
  sf_mex_destroy(&c19_b_is_active_c19_carsim);
  return c19_y;
}

static uint8_T c19_h_emlrt_marshallIn(SFc19_carsimInstanceStruct *chartInstance,
  const mxArray *c19_u, const emlrtMsgIdentifier *c19_parentId)
{
  uint8_T c19_y;
  uint8_T c19_u0;
  sf_mex_import(c19_parentId, sf_mex_dup(c19_u), &c19_u0, 1, 3, 0U, 0, 0U, 0);
  c19_y = c19_u0;
  sf_mex_destroy(&c19_u);
  return c19_y;
}

static void init_dsm_address_info(SFc19_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c19_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2408191611U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(595052863U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3216315396U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1466795285U);
}

mxArray *sf_c19_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("jy5uUa34XSXK1Q0jCembR");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c19_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[11],T\"st\",},{M[1],M[5],T\"th\",},{M[8],M[0],T\"is_active_c19_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c19_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc19_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc19_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          19,
          1,
          1,
          10,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"v");
          _SFD_SET_DATA_PROPS(1,1,1,0,"beta");
          _SFD_SET_DATA_PROPS(2,1,1,0,"psi_dot");
          _SFD_SET_DATA_PROPS(3,10,0,0,"l_front");
          _SFD_SET_DATA_PROPS(4,1,1,0,"tau");
          _SFD_SET_DATA_PROPS(5,1,1,0,"delta");
          _SFD_SET_DATA_PROPS(6,2,0,1,"th");
          _SFD_SET_DATA_PROPS(7,2,0,1,"st");
          _SFD_SET_DATA_PROPS(8,10,0,0,"m_car");
          _SFD_SET_DATA_PROPS(9,10,0,0,"mu");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,286);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c19_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c19_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c19_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c19_sf_marshallOut,(MexInFcnForType)c19_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c19_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c19_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c19_sf_marshallOut,(MexInFcnForType)c19_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c19_sf_marshallOut,(MexInFcnForType)c19_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c19_sf_marshallOut,(MexInFcnForType)c19_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c19_sf_marshallOut,(MexInFcnForType)c19_sf_marshallIn);

        {
          real_T *c19_v;
          real_T *c19_beta;
          real_T *c19_psi_dot;
          real_T *c19_delta;
          real_T *c19_th;
          real_T *c19_st;
          real_T (*c19_tau)[3];
          c19_st = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c19_th = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c19_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c19_tau = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
          c19_psi_dot = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c19_beta = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c19_v = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c19_v);
          _SFD_SET_DATA_VALUE_PTR(1U, c19_beta);
          _SFD_SET_DATA_VALUE_PTR(2U, c19_psi_dot);
          _SFD_SET_DATA_VALUE_PTR(3U, &chartInstance->c19_l_front);
          _SFD_SET_DATA_VALUE_PTR(4U, *c19_tau);
          _SFD_SET_DATA_VALUE_PTR(5U, c19_delta);
          _SFD_SET_DATA_VALUE_PTR(6U, c19_th);
          _SFD_SET_DATA_VALUE_PTR(7U, c19_st);
          _SFD_SET_DATA_VALUE_PTR(8U, &chartInstance->c19_m_car);
          _SFD_SET_DATA_VALUE_PTR(9U, &chartInstance->c19_mu);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c19_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc19_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c19_carsim((SFc19_carsimInstanceStruct*) chartInstanceVar);
  initialize_c19_carsim((SFc19_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c19_carsim(void *chartInstanceVar)
{
  enable_c19_carsim((SFc19_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c19_carsim(void *chartInstanceVar)
{
  disable_c19_carsim((SFc19_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c19_carsim(void *chartInstanceVar)
{
  sf_c19_carsim((SFc19_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c19_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c19_carsim((SFc19_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c19_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c19_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c19_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c19_carsim((SFc19_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c19_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c19_carsim(S);
}

static void sf_opaque_set_sim_state_c19_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c19_carsim(S, st);
}

static void sf_opaque_terminate_c19_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc19_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c19_carsim((SFc19_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc19_carsim((SFc19_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c19_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c19_carsim((SFc19_carsimInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c19_carsim(SimStruct *S)
{
  /* Actual parameters from chart:
     l_front m_car mu
   */
  const char_T *rtParamNames[] = { "p1", "p2", "p3" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for l_front*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for m_car*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for mu*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,19);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,19,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,19,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,19,5);
      sf_mark_chart_reusable_outputs(S,infoStruct,19,2);
    }

    sf_set_rtw_dwork_info(S,infoStruct,19);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1259858733U));
  ssSetChecksum1(S,(3085393341U));
  ssSetChecksum2(S,(3036817881U));
  ssSetChecksum3(S,(3156594268U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c19_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c19_carsim(SimStruct *S)
{
  SFc19_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc19_carsimInstanceStruct *)malloc(sizeof
    (SFc19_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc19_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c19_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c19_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c19_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c19_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c19_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c19_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c19_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c19_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c19_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c19_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c19_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c19_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c19_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c19_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c19_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c19_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
